package ifneeded cwind 1.5.1 [string map [list @ $dir] {

  load [file join {@} cwind151[info sharedlibextension]]

  namespace eval ::cwind {

    # Wait for a window named 'title'
    proc waitwind {title {maxSeconds 5} } {
      set delay 100
      set maxSeconds [expr {$maxSeconds * 1000 / $delay}]
      for {set i 1} { ! [string match $title [::cwind::gettext]] && $i <= $maxSeconds } {incr i} {
	after $delay
	update
      }
      if { $i > $maxSeconds } {
	return -code error "Cannot find window with title \"$title\""
      }
    }

    # Minimize all windows
    proc minimizeAll {} {
      foreach elem [::cwind::wlist] {
	if { [::cwind::state -exact $elem] ne "Minimized" } {
	  ::cwind::show -exact $elem
	  after 100
	  ::cwind::minimize
	}
      }
    }

    namespace export waitwind minimizeAll
  }}]
