// $Id: sctab.cpp 1.3 2001/10/11 11:09:52 s-imai s-imai $
//
// Copyright (C) 2000-2001 Satoshi Imai
//

#include "cwind.h"

// XyVELN^Ee[u
struct SpecialChar SpecialChar[] = {
	{ "|TAB|",		VK_TAB,		0 },
	{ "|RET|",		VK_RETURN,	0 },
	{ "|CLR|",		VK_CLEAR,	0 },
	{ "|ESC|",		VK_ESCAPE,	0 },
	{ "|BACK|",		VK_BACK,	0 },
	{ "|DEL|",		VK_DELETE,	0 },
	{ "|INS|",		VK_INSERT,	0 },
	{ "|HELP|",		VK_HELP,	0 },
	{ "|LEFT|",		VK_LEFT,	0 },
	{ "|RIGHT|",	VK_RIGHT,	0 },
	{ "|UP|",		VK_UP,		0 },
	{ "|DOWN|",		VK_DOWN,	0 },
	{ "|PGUP|",		VK_PRIOR,	0 },
	{ "|PGDN|",		VK_NEXT,	0 },
	{ "|HOME|",		VK_HOME,	0 },
	{ "|END|",		VK_END,		0 },
	{ "|SPACE|",	VK_SPACE,	0 },
	{ "|SEL|",		VK_SELECT,	0 },
	{ "|PRINT|",	VK_PRINT,	0 },
	{ "|EXEC|",		VK_EXECUTE,	0 },
	{ "|SNAP|",		VK_SNAPSHOT,	0 },
#ifdef VK_KANA
	{ "|KANA|",		VK_KANA,	0 },
#endif
#ifdef VK_HANGUL
	{ "|HANGUL|",	VK_HANGUL,	0 },
#endif
#ifdef VK_JUNJA
	{ "|JUNJA|",	VK_JUNJA,	0 },
#endif
#ifdef VK_FINAL
	{ "|FINAL|",	VK_FINAL,	0 },
#endif
#ifdef VK_HANJA
	{ "|HANJA|",	VK_HANJA,	0 },
#endif
#ifdef VK_KANJI
	{ "|KANJI|",	VK_KANJI,	0 },
#endif
#ifdef VK_CONVERT
	{ "|CONV|",		VK_CONVERT,	0 },
#endif
#ifdef VK_NONCONVERT
	{ "|NCONV|",	VK_NONCONVERT,	0 },
#endif
#ifdef VK_ACCEPT
	{ "|ACCEPT|",	VK_ACCEPT,	0 },
#endif
#ifdef VK_MODECHANGE
	{ "|MODE|",		VK_MODECHANGE,	0 },
#endif
	{ "|F1|",		VK_F1,		0 },
	{ "|F2|",		VK_F2,		0 },
	{ "|F3|",		VK_F3,		0 },
	{ "|F4|",		VK_F4,		0 },
	{ "|F5|",		VK_F5,		0 },
	{ "|F6|",		VK_F6,		0 },
	{ "|F7|",		VK_F7,		0 },
	{ "|F8|",		VK_F8,		0 },
	{ "|F9|",		VK_F9,		0 },
	{ "|F10|",		VK_F10,		0 },
	{ "|F11|",		VK_F11,		0 },
	{ "|F12|",		VK_F12,		0 },
	{ "|LWIN|",		VK_LWIN,	0 },
	{ "|RWIN|",		VK_RWIN,	0 },
	{ "|APPS|",		VK_APPS,	0 },
	{ "|NUM0|",		VK_NUMPAD0,	0 },
	{ "|NUM1|",		VK_NUMPAD1,	0 },
	{ "|NUM2|",		VK_NUMPAD2,	0 },
	{ "|NUM3|",		VK_NUMPAD3,	0 },
	{ "|NUM4|",		VK_NUMPAD4,	0 },
	{ "|NUM5|",		VK_NUMPAD5,	0 },
	{ "|NUM6|",		VK_NUMPAD6,	0 },
	{ "|NUM7|",		VK_NUMPAD7,	0 },
	{ "|NUM8|",		VK_NUMPAD8,	0 },
	{ "|NUM9|",		VK_NUMPAD9,	0 },
	{ "|NUM*|",		VK_MULTIPLY,	0 },
	{ "|NUM+|",		VK_ADD,		0 },
	{ "|NUM,|",		VK_SEPARATOR,	0 },
	{ "|NUM-|",		VK_SUBTRACT,	0 },
	{ "|NUM#|",		VK_DECIMAL,	0 },
	{ "|NUM.|",		VK_DECIMAL,	0 },
	{ "|NUM/|",		VK_DIVIDE,	0 },
	{ "|ALT+|",		VK_MENU,	0 },
	{ "|ALT-|",		VK_MENU,	KEYEVENTF_KEYUP },
	{ "|ALTL+|",	VK_MENU,	0 },
	{ "|ALTL-|",	VK_MENU,	KEYEVENTF_KEYUP },
	{ "|ALTR+|",	VK_MENU,	0|KEYEVENTF_EXTENDEDKEY },
	{ "|ALTR-|",	VK_MENU,	KEYEVENTF_KEYUP|KEYEVENTF_EXTENDEDKEY },
	{ "|CTRL+|",	VK_CONTROL,	0 },
	{ "|CTRL-|",	VK_CONTROL,	KEYEVENTF_KEYUP },
	{ "|CTRLL+|",	VK_CONTROL,	0 },
	{ "|CTRLL-|",	VK_CONTROL,	KEYEVENTF_KEYUP },
	{ "|CTRLR+|",	VK_CONTROL,	0|KEYEVENTF_EXTENDEDKEY },
	{ "|CTRLR-|",	VK_CONTROL,	KEYEVENTF_KEYUP|KEYEVENTF_EXTENDEDKEY },
	{ "|SHIFT+|",	VK_SHIFT,	0 },
	{ "|SHIFT-|",	VK_SHIFT,	KEYEVENTF_KEYUP },
	{ "|SHIFTL+|",	VK_SHIFT,	0 },
	{ "|SHIFTL-|",	VK_SHIFT,	KEYEVENTF_KEYUP },
	{ "|SHIFTR+|",	VK_SHIFT,	0|KEYEVENTF_EXTENDEDKEY },
	{ "|SHIFTR-|",	VK_SHIFT,	KEYEVENTF_KEYUP|KEYEVENTF_EXTENDEDKEY },
	{ NULL,		0,		0 }
};
