// $Id: setfg.cpp 1.1 2003/05/17 10:51:08 s-imai s-imai $
//
// Copyright (C) 2000-2003 Satoshi Imai
//

#include "cwind.h"

#define SPI_GETFOREGROUNDLOCKTIMEOUT	0x2000
#define SPI_SETFOREGROUNDLOCKTIMEOUT	0x2001

BOOL
MySetForegroundWindow(HWND hWnd)
{
	int nTargetID, nForegroundID;
	DWORD sp_time;
	int ret;

	// Retrieves the identifier of the thread that created the specified
	// window and, optionally, the identifier of the process that created
	// the window.
	nForegroundID = GetWindowThreadProcessId(GetForegroundWindow(), NULL);
	// Retrieves the identifier of the thread that created the specified
	// window and, optionally, the identifier of the process that created
	// the window.
	//
	// hWnd is the target window that we wish to make current
	nTargetID = GetWindowThreadProcessId(hWnd, NULL );

	// Attaches or detaches the input processing mechanism of one thread
	// to that of another thread.
	AttachThreadInput(nTargetID, nForegroundID, TRUE );  // TRUE: attach the two threads

	// Retrieves or sets the value of one of the system-wide parameters.
	// This function can also update the user profile while setting a
	// parameter.
	//
	// Retrieves the amount of time following user input, in milliseconds,
	// during which the system will not allow applications to force
	// themselves into the foreground. The pvParam parameter must point to
	// a DWORD variable that receives the time.
	SystemParametersInfo(SPI_GETFOREGROUNDLOCKTIMEOUT, 0, (LPVOID)&sp_time, 0);
	// Retrieves or sets the value of one of the system-wide parameters.
	// This function can also update the user profile while setting a
	// parameter.
	//
	// Sets the amount of time following user input, in milliseconds,
	// during which the system does not allow applications to force
	// themselves into the foreground. Set pvParam to the new time-out
	// value.
	//
	// The calling thread must be able to change the foreground window,
	// otherwise the call fails.
	SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, (LPVOID)0, 0);

	// Brings the thread that created the specified window into the
	// foreground and activates the window. Keyboard input is directed to
	// the window, and various visual cues are changed for the user. The
	// system assigns a slightly higher priority to the thread that
	// created the foreground window than it does to other threads.
	ret = SetForegroundWindow(hWnd);

	// Retrieves or sets the value of one of the system-wide parameters.
	// This function can also update the user profile while setting a
	// parameter.
	//
	// Sets the amount of time following user input, in milliseconds,
	// during which the system does not allow applications to force
	// themselves into the foreground. Set pvParam to the new time-out
	// value.
	//
	// The calling thread must be able to change the foreground window,
	// otherwise the call fails.
	SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, &sp_time, 0);

	// Attaches or detaches the input processing mechanism of one thread
	// to that of another thread.
	AttachThreadInput(nTargetID, nForegroundID, FALSE );  // FALSE: detach the two threads
	
	return ret;
}
