# $Id: wmtab.tcl 1.1 2001/08/27 07:14:18 s-imai s-imai $
#
# wmtab.c Generator
#

# Usage: tclsh wmtab.tcl <full path to wmuser.h>

if { $argc != 1 } {
  puts stderr "Usage: [info script] full-path-to-wmuser.h"
  exit 1
}

set WINUSER [lindex $argv 0]

if { ! [file exists $WINUSER] } {
  puts stderr "[info script]: No such file: $WINUSER"
  exit 1
}
if { ! [file readable $WINUSER] } {
  puts stderr "[info script]: Cannot read: $WINUSER"
  exit 1
}

set f [open $WINUSER r]
set o [open "wmtab.c" w]
set wm() ""
puts $o "#include \"cwind.h\""
puts $o ""
puts $o "struct WmCommand WmCommand\[\]={"
while { [ gets $f line ] >=0} {
  set cmd ""
  regexp "WM_\[A-Z_]*" $line cmd
  if {$cmd!="" & [array get wm $cmd]==""} {
    puts $o "#ifdef $cmd"
    puts $o "  {\"$cmd\", $cmd},"
    puts $o "#endif"
    set wm($cmd) "1"
  }
}
puts $o "  {NULL, 0},"
puts $o "};"
close $o
close $f
